diff -Naur --no-dereference a/drivers/base/power/opp/debugfs.c b/drivers/base/power/opp/debugfs.c
--- a/drivers/base/power/opp/debugfs.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/base/power/opp/debugfs.c	2018-03-06 12:52:47.273686057 -0500
@@ -0,0 +1,218 @@
+/*
+ * Generic OPP debugfs interface
+ *
+ * Copyright (C) 2015-2016 Viresh Kumar <viresh.kumar@linaro.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
+
+#include <linux/debugfs.h>
+#include <linux/device.h>
+#include <linux/err.h>
+#include <linux/init.h>
+#include <linux/limits.h>
+
+#include "opp.h"
+
+static struct dentry *rootdir;
+
+static void opp_set_dev_name(const struct device *dev, char *name)
+{
+	if (dev->parent)
+		snprintf(name, NAME_MAX, "%s-%s", dev_name(dev->parent),
+			 dev_name(dev));
+	else
+		snprintf(name, NAME_MAX, "%s", dev_name(dev));
+}
+
+void opp_debug_remove_one(struct dev_pm_opp *opp)
+{
+	debugfs_remove_recursive(opp->dentry);
+}
+
+int opp_debug_create_one(struct dev_pm_opp *opp, struct opp_table *opp_table)
+{
+	struct dentry *pdentry = opp_table->dentry;
+	struct dentry *d;
+	char name[25];	/* 20 chars for 64 bit value + 5 (opp:\0) */
+
+	/* Rate is unique to each OPP, use it to give opp-name */
+	snprintf(name, sizeof(name), "opp:%lu", opp->rate);
+
+	/* Create per-opp directory */
+	d = debugfs_create_dir(name, pdentry);
+	if (!d)
+		return -ENOMEM;
+
+	if (!debugfs_create_bool("available", S_IRUGO, d, &opp->available))
+		return -ENOMEM;
+
+	if (!debugfs_create_bool("dynamic", S_IRUGO, d, &opp->dynamic))
+		return -ENOMEM;
+
+	if (!debugfs_create_bool("turbo", S_IRUGO, d, &opp->turbo))
+		return -ENOMEM;
+
+	if (!debugfs_create_bool("suspend", S_IRUGO, d, &opp->suspend))
+		return -ENOMEM;
+
+	if (!debugfs_create_ulong("rate_hz", S_IRUGO, d, &opp->rate))
+		return -ENOMEM;
+
+	if (!debugfs_create_ulong("u_volt_target", S_IRUGO, d, &opp->u_volt))
+		return -ENOMEM;
+
+	if (!debugfs_create_ulong("u_volt_min", S_IRUGO, d, &opp->u_volt_min))
+		return -ENOMEM;
+
+	if (!debugfs_create_ulong("u_volt_max", S_IRUGO, d, &opp->u_volt_max))
+		return -ENOMEM;
+
+	if (!debugfs_create_ulong("u_amp", S_IRUGO, d, &opp->u_amp))
+		return -ENOMEM;
+
+	if (!debugfs_create_ulong("clock_latency_ns", S_IRUGO, d,
+				  &opp->clock_latency_ns))
+		return -ENOMEM;
+
+	opp->dentry = d;
+	return 0;
+}
+
+static int opp_list_debug_create_dir(struct opp_device *opp_dev,
+				     struct opp_table *opp_table)
+{
+	const struct device *dev = opp_dev->dev;
+	struct dentry *d;
+
+	opp_set_dev_name(dev, opp_table->dentry_name);
+
+	/* Create device specific directory */
+	d = debugfs_create_dir(opp_table->dentry_name, rootdir);
+	if (!d) {
+		dev_err(dev, "%s: Failed to create debugfs dir\n", __func__);
+		return -ENOMEM;
+	}
+
+	opp_dev->dentry = d;
+	opp_table->dentry = d;
+
+	return 0;
+}
+
+static int opp_list_debug_create_link(struct opp_device *opp_dev,
+				      struct opp_table *opp_table)
+{
+	const struct device *dev = opp_dev->dev;
+	char name[NAME_MAX];
+	struct dentry *d;
+
+	opp_set_dev_name(opp_dev->dev, name);
+
+	/* Create device specific directory link */
+	d = debugfs_create_symlink(name, rootdir, opp_table->dentry_name);
+	if (!d) {
+		dev_err(dev, "%s: Failed to create link\n", __func__);
+		return -ENOMEM;
+	}
+
+	opp_dev->dentry = d;
+
+	return 0;
+}
+
+/**
+ * opp_debug_register - add a device opp node to the debugfs 'opp' directory
+ * @opp_dev: opp-dev pointer for device
+ * @opp_table: the device-opp being added
+ *
+ * Dynamically adds device specific directory in debugfs 'opp' directory. If the
+ * device-opp is shared with other devices, then links will be created for all
+ * devices except the first.
+ *
+ * Return: 0 on success, otherwise negative error.
+ */
+int opp_debug_register(struct opp_device *opp_dev, struct opp_table *opp_table)
+{
+	if (!rootdir) {
+		pr_debug("%s: Uninitialized rootdir\n", __func__);
+		return -EINVAL;
+	}
+
+	if (opp_table->dentry)
+		return opp_list_debug_create_link(opp_dev, opp_table);
+
+	return opp_list_debug_create_dir(opp_dev, opp_table);
+}
+
+static void opp_migrate_dentry(struct opp_device *opp_dev,
+			       struct opp_table *opp_table)
+{
+	struct opp_device *new_dev;
+	const struct device *dev;
+	struct dentry *dentry;
+
+	/* Look for next opp-dev */
+	list_for_each_entry(new_dev, &opp_table->dev_list, node)
+		if (new_dev != opp_dev)
+			break;
+
+	/* new_dev is guaranteed to be valid here */
+	dev = new_dev->dev;
+	debugfs_remove_recursive(new_dev->dentry);
+
+	opp_set_dev_name(dev, opp_table->dentry_name);
+
+	dentry = debugfs_rename(rootdir, opp_dev->dentry, rootdir,
+				opp_table->dentry_name);
+	if (!dentry) {
+		dev_err(dev, "%s: Failed to rename link from: %s to %s\n",
+			__func__, dev_name(opp_dev->dev), dev_name(dev));
+		return;
+	}
+
+	new_dev->dentry = dentry;
+	opp_table->dentry = dentry;
+}
+
+/**
+ * opp_debug_unregister - remove a device opp node from debugfs opp directory
+ * @opp_dev: opp-dev pointer for device
+ * @opp_table: the device-opp being removed
+ *
+ * Dynamically removes device specific directory from debugfs 'opp' directory.
+ */
+void opp_debug_unregister(struct opp_device *opp_dev,
+			  struct opp_table *opp_table)
+{
+	if (opp_dev->dentry == opp_table->dentry) {
+		/* Move the real dentry object under another device */
+		if (!list_is_singular(&opp_table->dev_list)) {
+			opp_migrate_dentry(opp_dev, opp_table);
+			goto out;
+		}
+		opp_table->dentry = NULL;
+	}
+
+	debugfs_remove_recursive(opp_dev->dentry);
+
+out:
+	opp_dev->dentry = NULL;
+}
+
+static int __init opp_debug_init(void)
+{
+	/* Create /sys/kernel/debug/opp directory */
+	rootdir = debugfs_create_dir("opp", NULL);
+	if (!rootdir) {
+		pr_err("%s: Failed to create root directory\n", __func__);
+		return -ENOMEM;
+	}
+
+	return 0;
+}
+core_initcall(opp_debug_init);
diff -Naur --no-dereference a/drivers/base/power/opp/domain.c b/drivers/base/power/opp/domain.c
--- a/drivers/base/power/opp/domain.c	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/base/power/opp/domain.c	2018-03-06 12:52:47.273686057 -0500
@@ -0,0 +1,553 @@
+/*
+ * OPP Domain Core interface
+ *
+ * Copyright (C) 2016 Texas Instruments Incorporated - http://www.ti.com/
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * OPP domain handles scaling of clocks and regulators for a device when
+ * changing OPPs. Default configuration that will be handled without any
+ * opp domain platform driver is one clock and one regulator per device.
+ */
+#include <linux/clk.h>
+#include <linux/device.h>
+#include <linux/of.h>
+#include <linux/module.h>
+#include <linux/pm_opp_domain.h>
+#include <linux/regulator/consumer.h>
+#include <linux/slab.h>
+
+#include "opp.h"
+#include "domain.h"
+
+static DEFINE_MUTEX(pm_oppdm_list_lock);
+static LIST_HEAD(pm_oppdm_list);
+
+static struct pm_opp_domain_dev *opp_domain_parse_of(struct device_node *np,
+						     const char *supply)
+{
+	char prop_name[32];	/* 32 is max size of property name */
+	bool found = false;
+	struct device_node *oppdm_np;
+	struct pm_opp_domain_dev *oppdm_dev = NULL;
+
+	snprintf(prop_name, sizeof(prop_name), "%s-opp-domain", supply);
+	oppdm_np = of_parse_phandle(np, prop_name, 0);
+	if (oppdm_np) {
+		mutex_lock(&pm_oppdm_list_lock);
+		list_for_each_entry(oppdm_dev, &pm_oppdm_list, node)
+			if (oppdm_dev->dev && oppdm_np ==
+			    oppdm_dev->dev->of_node) {
+				found = true;
+				break;
+			}
+		mutex_unlock(&pm_oppdm_list_lock);
+
+		/* if node is present and not ready, then defer */
+		if (!found)
+			return ERR_PTR(-EPROBE_DEFER);
+	} else {
+		return NULL;
+	}
+
+	of_node_put(oppdm_np);
+	return oppdm_dev;
+}
+
+static int _set_opp_domain_voltage(struct pm_opp_domain *pod,
+				   struct regulator *reg,
+				   int flags, unsigned long u_volt,
+				   unsigned long u_volt_min,
+				   unsigned long u_volt_max)
+{
+	struct device *dev = pod->dev;
+	struct pm_opp_domain_dev *oppdm_dev = pod->oppdm_dev;
+	int ret;
+
+	if (oppdm_dev) {
+		const struct pm_opp_domain_ops *ops;
+
+		if (IS_ERR(oppdm_dev))
+			return PTR_ERR(oppdm_dev);
+
+		ops = oppdm_dev->desc->ops;
+
+		ret = ops->oppdm_do_transition(oppdm_dev->dev,
+					       pod->data,
+					       flags, u_volt, u_volt_min,
+					       u_volt_max);
+	} else {
+		/* Regulator not available for device */
+		if (IS_ERR(reg)) {
+			dev_dbg(dev, "%s: regulator not available: %ld\n",
+				__func__, PTR_ERR(reg));
+			return 0;
+		}
+
+		dev_dbg(dev, "%s: voltages (mV): %lu %lu %lu\n", __func__,
+			u_volt_min, u_volt, u_volt_max);
+
+		ret = regulator_set_voltage_triplet(reg, u_volt_min, u_volt,
+						    u_volt_max);
+		if (ret)
+			dev_err(dev, "%s: failed to set voltage (%lu %lu %lu mV): %d\n",
+				__func__, u_volt_min, u_volt, u_volt_max, ret);
+	}
+
+	return ret;
+}
+
+/**
+ * dev_pm_opp_domain_set_rate() - Set voltage and frequency for an opp domain
+ * @pod: Pointer to pm_opp_domain obtained with dev_pm_opp_domain_get
+ * @target_freq: Desired frequency to transition to in Hz
+ *
+ * Transition the clk and reg managed by opp_domain to the new operating point.
+ */
+int dev_pm_opp_domain_set_rate(struct pm_opp_domain *pod,
+			       unsigned long target_freq)
+{
+	struct device *dev = pod->dev;
+	struct dev_pm_opp *old_opp, *opp;
+	struct regulator *reg;
+	struct clk *clk;
+	unsigned long freq, old_freq;
+	unsigned long u_volt, u_volt_min, u_volt_max;
+	unsigned long ou_volt, ou_volt_min, ou_volt_max;
+	int ret;
+
+	if (unlikely(!target_freq)) {
+		dev_err(dev, "%s: Invalid target frequency %lu\n", __func__,
+			target_freq);
+		return -EINVAL;
+	}
+
+	clk = pod->clk;
+	if (IS_ERR(clk))
+		return PTR_ERR(clk);
+
+	freq = clk_round_rate(clk, target_freq);
+	if ((long)freq <= 0)
+		freq = target_freq;
+
+	old_freq = clk_get_rate(clk);
+
+	/* Return early if nothing to do */
+	if (old_freq == freq) {
+		dev_dbg(dev, "%s: old/new frequencies (%lu Hz) are same, nothing to do\n",
+			__func__, freq);
+		return 0;
+	}
+
+	rcu_read_lock();
+
+	old_opp = dev_pm_opp_find_freq_ceil(dev, &old_freq);
+	if (!IS_ERR(old_opp)) {
+		ou_volt = old_opp->u_volt;
+		ou_volt_min = old_opp->u_volt_min;
+		ou_volt_max = old_opp->u_volt_max;
+	} else {
+		dev_err(dev, "%s: failed to find current OPP for freq %lu (%ld)\n",
+			__func__, old_freq, PTR_ERR(old_opp));
+	}
+
+	opp = dev_pm_opp_find_freq_ceil(dev, &freq);
+	if (IS_ERR(opp)) {
+		ret = PTR_ERR(opp);
+		dev_err(dev, "%s: failed to find OPP for freq %lu (%d)\n",
+			__func__, freq, ret);
+		rcu_read_unlock();
+		return ret;
+	}
+
+	u_volt = opp->u_volt;
+	u_volt_min = opp->u_volt_min;
+	u_volt_max = opp->u_volt_max;
+
+	reg = pod->reg;
+
+	rcu_read_unlock();
+
+	/* Scaling up? Scale voltage before frequency */
+	if (freq > old_freq) {
+		ret = _set_opp_domain_voltage(pod, reg, PM_OPPDM_VOLT_PRERATE,
+					      u_volt, u_volt_min,
+					      u_volt_max);
+		if (ret)
+			goto restore_voltage;
+	}
+
+	/* Change frequency */
+
+	dev_dbg(dev, "%s: switching OPP: %lu Hz --> %lu Hz\n",
+		__func__, old_freq, freq);
+
+	ret = clk_set_rate(clk, freq);
+	if (ret) {
+		dev_err(dev, "%s: failed to set clock rate: %d\n", __func__,
+			ret);
+		goto restore_voltage;
+	}
+
+	/* Scaling down? Scale voltage after frequency */
+	if (freq < old_freq) {
+		ret = _set_opp_domain_voltage(pod, reg, PM_OPPDM_VOLT_POSTRATE,
+					      u_volt, u_volt_min,
+					      u_volt_max);
+		if (ret)
+			goto restore_freq;
+	}
+
+	return 0;
+
+restore_freq:
+	if (clk_set_rate(clk, old_freq))
+		dev_err(dev, "%s: failed to restore old-freq (%lu Hz)\n",
+			__func__, old_freq);
+restore_voltage:
+	/* This shouldn't harm even if the voltages weren't updated earlier */
+	if (!IS_ERR(old_opp))
+		_set_opp_domain_voltage(pod, reg, PM_OPPDM_VOLT_ABORTRATE,
+					ou_volt, ou_volt_min, ou_volt_max);
+
+	return ret;
+}
+
+/**
+ * dev_pm_opp_domain_get() - Get a handle to opp_domain for device
+ * @dev: Pointer to the device for which opp_domain handle is needed
+ *
+ * This creates a pm_opp_domain and parses proper clock for the
+ * device so it can be managed. Will defer if resources are
+ * not yet available.
+ *
+ * NOTE: dev_pm_opp_set_supply MUST be called after this if a regulator
+ * or OPP domain platform driver will be used.
+ */
+struct pm_opp_domain *dev_pm_opp_domain_get(struct device *dev)
+{
+	struct pm_opp_domain *pod;
+	int ret = 0;
+
+	pod = kzalloc(sizeof(*pod), GFP_KERNEL);
+	if (!pod)
+		return ERR_PTR(-ENOMEM);
+
+	pod->dev = dev;
+	pod->reg = ERR_PTR(-ENXIO);
+
+	/* Find clk for the device */
+	pod->clk = clk_get(dev, NULL);
+	if (IS_ERR(pod->clk)) {
+		ret = PTR_ERR(pod->clk);
+		if (ret != -EPROBE_DEFER)
+			dev_dbg(dev, "%s: Couldn't find clock: %d\n", __func__,
+				ret);
+		goto err;
+	}
+
+	return pod;
+err:
+	kfree(pod);
+	return ERR_PTR(ret);
+}
+
+/**
+ * dev_pm_opp_domain_put() - Release an opp_domain
+ * @pod: Pointer to the opp_domain to be released
+ *
+ * Returns -EBUSY if regulator hasn't been released by , otherwise 0
+ */
+int dev_pm_opp_domain_put(struct pm_opp_domain *pod)
+{
+	if (!IS_ERR_OR_NULL(pod->reg)) {
+		dev_dbg(pod->dev, "%s called without putting regulator first\n",
+			__func__);
+		return -EBUSY;
+	}
+
+	if (!IS_ERR(pod->reg))
+		regulator_put(pod->reg);
+
+	if (!IS_ERR(pod->clk))
+		clk_put(pod->clk);
+
+	kfree(pod);
+	return 0;
+}
+
+/**
+ * dev_pm_opp_domain_get_supply() - Acquire supply for opp_domain
+ * @pod: Pointer to valid pm_opp_domain acquired with dev_pm_opp_domain_get
+ * @supply: Name of the supply.
+ *
+ * This parses proper regulator for the device so it can be managed. Will defer
+ * if resource is not yet available.
+ *
+ * NOTE: This is called under mutex protection by the OPP core.
+ */
+int dev_pm_opp_domain_get_supply(struct pm_opp_domain *pod,
+				 const char *supply)
+{
+	struct pm_opp_domain_dev *oppdm_dev = NULL;
+	int ret = 0;
+
+	if (!pod)
+		return -EINVAL;
+
+	/* First look for opp_domain of node */
+	oppdm_dev = opp_domain_parse_of(pod->dev->of_node, supply);
+	if (IS_ERR(oppdm_dev))
+		return PTR_ERR(oppdm_dev);
+
+	if (oppdm_dev) {
+		const struct pm_opp_domain_ops *ops;
+
+		pod->oppdm_dev = oppdm_dev;
+
+		if (!try_module_get(oppdm_dev->dev->driver->owner)) {
+			ret = -ENODEV;
+		} else {
+			ops = oppdm_dev->desc->ops;
+			if (ops->oppdm_get)
+				ret = ops->oppdm_get(oppdm_dev->dev, pod->dev,
+						     pod->dev->of_node,
+						     supply,
+						     &pod->data);
+			if (ret)
+				module_put(oppdm_dev->dev->driver->owner);
+		}
+	} else {
+		pod->reg = regulator_get_optional(pod->dev, supply);
+		if (IS_ERR(pod->reg)) {
+			ret = PTR_ERR(pod->reg);
+			/* Regulator is not mandatory */
+			if (ret != -EPROBE_DEFER)
+				dev_dbg(pod->dev, "%s: Couldn't find regulator: %d\n",
+					__func__, ret);
+		}
+	}
+
+	return ret;
+}
+
+/**
+ * dev_pm_opp_domain_put_supply() - Release an opp_domain supply
+ * @pod: Pointer to the opp_domain to release supply for
+ *
+ * NOTE: This is called under mutex protection by the OPP core.
+ */
+void dev_pm_opp_domain_put_supply(struct pm_opp_domain *pod)
+{
+	struct pm_opp_domain_dev *oppdm_dev = pod->oppdm_dev;
+
+	if (oppdm_dev) {
+		const struct pm_opp_domain_ops *ops;
+
+		if (IS_ERR(oppdm_dev))
+			return;
+
+		ops = oppdm_dev->desc->ops;
+		if (ops->oppdm_put)
+			ops->oppdm_put(oppdm_dev->dev, pod->dev, pod->data);
+		module_put(oppdm_dev->dev->driver->owner);
+	} else {
+		if (!IS_ERR_OR_NULL(pod->reg)) {
+			regulator_put(pod->reg);
+			pod->reg = NULL;
+		}
+	}
+}
+
+/**
+ * dev_pm_opp_domain_get_latency() - provide the latency for the opp domain
+ * @pod: Pointer to valid pm_opp_domain acquired with dev_pm_opp_domain_get
+ * @old_uV: starting voltage in microvolts
+ * @old_uV_min: minimum acceptable starting voltage in microvolts
+ * @old_uV_max: maximum acceptable starting voltage in microvolts
+ * @new_uV: target voltage in microvolts
+ * @new_uV_min: minimum acceptable target voltage in microvolts
+ * @new_uV_max: maximum acceptable target voltage in microvolts
+ *
+ * Return: If successful, the combined transition latency from min to max, else
+ * returns error value
+ */
+int dev_pm_opp_domain_get_latency(struct pm_opp_domain *pod, int old_uV,
+				  int old_uV_min, int old_uV_max, int new_uV,
+				  int new_uV_min, int new_uV_max)
+{
+	int total_latency = 0;
+
+	struct pm_opp_domain_dev *oppdm_dev = pod->oppdm_dev;
+
+	if (oppdm_dev) {
+		const struct pm_opp_domain_ops *ops;
+
+		if (IS_ERR(oppdm_dev))
+			return 0;
+
+		ops = oppdm_dev->desc->ops;
+		if (ops->oppdm_get_latency)
+			total_latency += ops->oppdm_get_latency(oppdm_dev->dev,
+								pod->data,
+								old_uV,
+								old_uV_min,
+								old_uV_max,
+								new_uV,
+								new_uV_min,
+								new_uV_max);
+	} else {
+		if (!IS_ERR(pod->reg)) {
+			total_latency +=
+				regulator_set_voltage_time_triplet(pod->reg,
+								   old_uV,
+								   old_uV_min,
+								   old_uV_max,
+								   new_uV,
+								   new_uV_min,
+								   new_uV_max);
+		}
+	}
+
+	return total_latency;
+}
+
+/**
+ * dev_pm_opp_domain_opp_supported_by_supply() - opp domain supports voltage?
+ * @pod: Pointer to valid pm_opp_domain acquired with dev_pm_opp_domain_get
+ * @uV_min: minimum acceptable starting voltage in microvolts
+ * @uV_max: maximum acceptable starting voltage in microvolts
+ *
+ * NOTE: This is called under mutex protection by the OPP core.
+ *
+ * Returns: If voltage is supported return true, else return false.
+ */
+bool dev_pm_opp_domain_opp_supported_by_supply(struct pm_opp_domain *pod,
+					       unsigned long uV_min,
+					       unsigned long uV_max)
+{
+	struct pm_opp_domain_dev *oppdm_dev = pod->oppdm_dev;
+	int ret = 0;
+
+	if (oppdm_dev) {
+		const struct pm_opp_domain_ops *ops;
+
+		if (IS_ERR(oppdm_dev))
+			return PTR_ERR(oppdm_dev);
+
+		ops = oppdm_dev->desc->ops;
+
+		if (ops->oppdm_is_supported_voltage)
+			ret = ops->oppdm_is_supported_voltage(oppdm_dev->dev,
+							      pod->data,
+							      uV_min,
+							      uV_max);
+
+		if (!ret)
+			return false;
+	} else {
+		if (!IS_ERR(pod->reg) &&
+		    !regulator_is_supported_voltage(pod->reg, uV_min,
+						    uV_max))
+			return false;
+	}
+
+	return true;
+}
+
+static void devm_opp_domain_release(struct device *dev, void *res)
+{
+	struct pm_opp_domain_dev *oppdm_dev = *(struct pm_opp_domain_dev **)res;
+
+	mutex_lock(&pm_oppdm_list_lock);
+	list_del(&oppdm_dev->node);
+	mutex_unlock(&pm_oppdm_list_lock);
+
+	kfree(oppdm_dev);
+}
+
+/**
+ * devm_opp_domain_register - Resource managed opp domain registration
+ * @dev: pointer to the device representing the opp domain
+ * @desc: opp domain descriptor
+ *
+ * Called by opp domain drivers to register a opp domain.  Returns a
+ * valid pointer to struct pm_opp_domain_dev on success or an ERR_PTR() on
+ * error.  The opp domain will automatically be released when the device
+ * is unbound.
+ */
+struct pm_opp_domain_dev
+*devm_opp_domain_register(struct device *dev,
+			  const struct pm_opp_domain_desc *desc)
+{
+	struct pm_opp_domain_dev **ptr, *oppdm_dev;
+
+	if (!dev || !desc)
+		return ERR_PTR(-EINVAL);
+
+	if (!desc->ops)
+		return ERR_PTR(-EINVAL);
+
+	/* Mandatory to have notify transition */
+	if (!desc->ops->oppdm_do_transition) {
+		dev_err(dev, "%s: Bad desc: oppdm_do_transition missing\n",
+			__func__);
+		return ERR_PTR(-EINVAL);
+	}
+
+	oppdm_dev = kzalloc(sizeof(*oppdm_dev), GFP_KERNEL);
+	if (!oppdm_dev)
+		return ERR_PTR(-ENOMEM);
+
+	ptr = devres_alloc(devm_opp_domain_release, sizeof(*ptr), GFP_KERNEL);
+	if (!ptr) {
+		kfree(oppdm_dev);
+		return ERR_PTR(-ENOMEM);
+	}
+
+	oppdm_dev->desc = desc;
+	oppdm_dev->dev = dev;
+
+	mutex_lock(&pm_oppdm_list_lock);
+	list_add(&oppdm_dev->node, &pm_oppdm_list);
+	mutex_unlock(&pm_oppdm_list_lock);
+
+	*ptr = oppdm_dev;
+	devres_add(dev, ptr);
+
+	return oppdm_dev;
+}
+EXPORT_SYMBOL_GPL(devm_opp_domain_register);
+
+static int devm_oppdm_dev_match(struct device *dev, void *res, void *data)
+{
+	struct pm_opp_domain_dev **r = res;
+
+	if (!r || !*r) {
+		WARN_ON(!r || !*r);
+		return 0;
+	}
+	return *r == data;
+}
+
+/**
+ * devm_opp_domain_unregister - Resource managed opp domain unregister
+ * @oppdm_dev: opp domain device returned by devm_opp_domain_register()
+ *
+ * Unregister an opp domain registered with devm_opp_domain_register().
+ * Normally this function will not need to be called and the resource
+ * management code will ensure that the resource is freed.
+ */
+void devm_opp_domain_unregister(struct pm_opp_domain_dev *oppdm_dev)
+{
+	int rc;
+	struct device *dev = oppdm_dev->dev;
+
+	rc = devres_release(dev, devm_opp_domain_release,
+			    devm_oppdm_dev_match, oppdm_dev);
+	if (rc != 0)
+		WARN_ON(rc);
+}
+EXPORT_SYMBOL_GPL(devm_opp_domain_unregister);
diff -Naur --no-dereference a/drivers/base/power/opp/domain.h b/drivers/base/power/opp/domain.h
--- a/drivers/base/power/opp/domain.h	1969-12-31 19:00:00.000000000 -0500
+++ b/drivers/base/power/opp/domain.h	2018-03-06 12:52:47.273686057 -0500
@@ -0,0 +1,109 @@
+/*
+ * Generic OPP Domain Private
+ *
+ * Copyright (C) 2016 Texas Instruments Incorporated.
+ *	Dave Gerlach
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#ifndef __DRIVER_OPP_DOMAIN_H__
+#define __DRIVER_OPP_DOMAIN_H__
+
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/pm_opp.h>
+
+struct pm_opp_domain_desc;
+
+/**
+ * struct pm_opp_domain_dev - internal representation of opp domain devices
+ * @dev:	voltage domain device
+ * @node:	list to remaining voltage domain devices
+ * @node:	mutex to control data structure modifications and serialize ops
+ */
+struct pm_opp_domain_dev {
+	const struct pm_opp_domain_desc *desc;
+	struct device *dev;
+	struct list_head node;
+};
+
+/**
+ * struct pm_opp_domain - Structure to maintain opp domain info
+ * @dev:        device for which we scale clk and supply
+ * @clk:        clk which we must scale
+ * @reg:        regulator, if any, which is used for scaling voltage
+ * @data: opp_domain driver specific data
+ */
+struct pm_opp_domain {
+	struct device *dev;
+	struct clk *clk;
+	struct regulator *reg;
+	struct pm_opp_domain_dev *oppdm_dev;
+	void *data;
+};
+
+#if defined(CONFIG_PM_OPP)
+int dev_pm_opp_domain_set_rate(struct pm_opp_domain *pod,
+			       unsigned long target_freq);
+
+struct pm_opp_domain *dev_pm_opp_domain_get(struct device *dev);
+int dev_pm_opp_domain_put(struct pm_opp_domain *pod);
+
+int dev_pm_opp_domain_get_supply(struct pm_opp_domain *pod,
+				 const char *supply);
+void dev_pm_opp_domain_put_supply(struct pm_opp_domain *pod);
+
+int dev_pm_opp_domain_get_latency(struct pm_opp_domain *pod, int old_uV,
+				  int old_uV_min, int old_uV_max, int new_uV,
+				  int new_uV_min, int new_uV_max);
+bool dev_pm_opp_domain_opp_supported_by_supply(struct pm_opp_domain *pod,
+					       unsigned long uV_min,
+					       unsigned long uV_max);
+#else
+static inline int dev_pm_opp_domain_set_rate(struct pm_opp_domain *pod,
+					     unsigned long target_freq)
+{
+	return -ENODEV;
+}
+
+static inline struct pm_opp_domain *dev_pm_opp_domain_get(struct device *dev,
+							  const char *supply)
+{
+	return NULL;
+}
+
+static inline void dev_pm_opp_domain_put(struct pm_opp_domain *pod)
+{
+}
+
+static inline int dev_pm_opp_domain_get_supply(struct pm_opp_domain *pod,
+					       const char *supply)
+{
+	return -ENODEV;
+}
+
+static inline void dev_pm_opp_domain_put_supply(struct pm_opp_domain *pod)
+{
+}
+
+static inline int dev_pm_opp_domain_get_latency(struct pm_opp_domain *pod,
+						int old_uV, int old_uV_min,
+						int old_uV_max, int new_uV,
+						int new_uV_min, int new_uV_max)
+
+{
+	return -ENODEV;
+}
+
+static inline
+bool dev_pm_opp_domain_opp_supported_by_supply(struct pm_opp_domain *pod,
+					       unsigned long uV_min,
+					       unsigned long uV_max)
+{
+	return false;
+}
+#endif /* CONFIG_PM_OPP */
+#endif /* __DRIVER_OPP_DOMAIN_H__ */
diff -Naur --no-dereference a/drivers/base/power/opp/Makefile b/drivers/base/power/opp/Makefile
--- a/drivers/base/power/opp/Makefile	2018-01-23 13:50:18.000000000 -0500
+++ b/drivers/base/power/opp/Makefile	2018-03-06 12:52:47.273686057 -0500
@@ -1,2 +1,3 @@
 ccflags-$(CONFIG_DEBUG_DRIVER)	:= -DDEBUG
-obj-y				+= core.o cpu.o
+obj-y				+= core.o cpu.o domain.o
+obj-$(CONFIG_DEBUG_FS)		+= debugfs.o
